require "vsvipergen/version"
require 'vsvipergen'

module Vsvipergen
  # concrete class for VS<$filePrefix$>_adr.md
  class ViperAdrFileGenerator < Generator
    def init(prefix, now, year, projectName, orgName)
      super(prefix, now, year, projectName, orgName)
    end

    def makeFiles
      super

      subPath = currPath + "/adrs"
      Dir.mkdir(subPath) unless File.exist?(subPath)
      
      newHeaderFilePath = subPath + "/VS#{prefix.strip}_adr.md"
      generatedFilePaths.push(newHeaderFilePath)

      templateHeaderFilePath = File.expand_path '../lib/templates/architecturalDecisionRecordFile/VS<$$>_adr.md', File.dirname(__FILE__)

      templateHeaderFileContents = ViperFileReader.new.readFile(templateHeaderFilePath)

      ViperFileWriter.new.writeFile(newHeaderFilePath, templateHeaderFileContents)

      return generatedFilePaths
    end
  end
end